"""implements additional mathematical operations

This module implements same mathematical operations which are not provided by the standard math module. Attention: Using this module and the standard Python math module can lead to namespace problems.

@author: Robert Fischbach
@author: Tobias Heimpold
@copyright: Copyright (C) 2011
@license: This program is free software; you can redistribute it and/or modify it 
          under the terms of the GNU General Public License as published by the 
          Free Software Foundation; either version 3 of the License, or (at your 
          option) any later version.
          This program is distributed in the hope that it will be useful, but 
          WITHOUT ANY WARRANTY; without even the implied warranty of 
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
          Public License for more details.
          You should have received a copy of the GNU General Public License along 
          with this program; if not, see <http://www.gnu.org/licenses/>.
@contact: For questions and bugs send an email to <fischbach (at) ifte.de> 
"""
from __future__ import absolute_import

from math import factorial as fak
#from scipy import comb as n_over_k

"""
def fak(n):
    if n > 1:
        return fak(n-1)*n
    else:
        return 1
"""


"""
deprecated: use scipy.comb instead
def n_over_k(n, k):
    return fak(n)/(fak(k)*fak(n-k))
"""

def catalan_number(n):
    """Returns the Catlan Number of n.
    @param n: Is the number for the calculation of the Catlan Number.
    @type n: int
    @return: Returns the Catlan Number of n.
    @rtype: int
    """
    return fak(2*n)/((n+1)*fak(n)**2)
    #return fak(2*n)/(fak(n+1)*fak(n))
    
    